[inherit('common','pSolr')]
program search(input,output);

procedure dump(solr : solr_ctxptr; query : pstr);

var
   res : solr_query_res;
   i : integer;

begin
   writeln('search for : ' + query);
   res := psolr_query_df(solr, query, 'alltext');
   for i := 1 to psolr_hits(res) do begin
      writeln('  ', psolr_get_field(res, i-1, 'names'), ' - ', psolr_get_field(res, i-1, 'moves'));
   end;
end;

var
   solr : solr_ctxptr;

begin
   solr := psolr_setup('arnepc5', 8888, 'chessopening');
   (* all *)
   dump(solr, '*:*');
   (* one *)
   dump(solr, 'names:defense');
   dump(solr, 'moves:d4');
   (* dual *)
   dump(solr, 'alltext:defense');
   dump(solr, 'alltext:d4');
   dump(solr, 'defense'); (* default field *)
   dump(solr, 'd4'); (* default field *)
   (* boolean *)
   dump(solr, 'names:defense moves:d4'); (* implicit or *)
   dump(solr, 'names:defense AND moves:d4'); (* and *)
   dump(solr, 'names:defense NOT moves:d4'); (* not *)
   dump(solr, 'defense d4'); (* default field + implicit or *)
   dump(solr, 'defense AND d4'); (* default field + and *)
   dump(solr, 'defense NOT d4'); (* default field + not *)
   (* wildcard *)
   dump(solr, 'names:def*');
   dump(solr, 'moves:N*');
end.
